Prevent focus to previous element in EJ2 JavaScript Dialog control

30 Aug 20254 minutes to read

By default, when the dialog is closed, focus returns to the element that was previously focused before the dialog opened. You can prevent this behavior using the beforeClose event and setting the preventFocus argument to true.

Bind the beforeClose event and enable the preventFocus argument as shown in the sample below.

// Initialize the Dialog component using Syncfusion's Dialog class
var dialogObj = new ej.popups.Dialog({
    header: 'Delete Multiple Items',
    content: "Are you sure you want to permanently delete all of these items?",
    showCloseIcon: true,
    buttons: [
        { 
            buttonModel: { isPrimary: true, content: 'Yes' }, 
            click: btnClick
        },
        { 
            buttonModel: { content: 'No' }, 
            click: btnClick
        }
    ],
    // Specifies the target element where the dialog will be rendered
    target: document.body,
    height: 'auto',
    width: '300px',
    animationSettings: { effect: 'Zoom' },

    // Event triggered before the dialog closes
    beforeClose: function (args) {
        // Prevents the dialog from regaining focus after closing
        args.preventFocus = true;
    }
});

// Append the dialog to the DOM element with ID 'dialog'
dialogObj.appendTo('#dialog');
document.getElementById('openBtn').onclick = function () {
    dialogObj.show(); 
};

function btnClick() {
    dialogObj.hide(); 
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Dialog with header</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="TypeScript UI Components">
    <meta name="author" content="Syncfusion">
    <link href="styles.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-popups/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/31.1.17/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <button id="openBtn" class="e-control e-btn">Open</button>
        <div id="dialog"> </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Prevent focus to previous element in React Dialog component

29 Aug 202510 minutes to read

By default, when the dialog is closed, focus returns to the element that was previously focused before the dialog opened. You can prevent this behavior using the beforeClose event and setting the preventFocus argument to true.

Bind the beforeClose event and enable the preventFocus argument as shown in the sample below.

[Class-component]

import React, { useState } from 'react';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

const App = () => {
  const [visible, setVisible] = useState(false);

  const handleOpen = () => {
    setVisible(true);
  };

  const handleClose = () => {
    setVisible(false);
  };

  return (
    <div id="container" style=>
      <ButtonComponent onClick={handleOpen}>Open</ButtonComponent>
      <DialogComponent
        header="Delete Multiple Items"
        content="Are you sure you want to permanently delete all of these items?"
        showCloseIcon={true}
        visible={visible}
        width="300px"
        animationSettings=
        target="#container"
        beforeClose={(args) => {
          args.preventFocus = true;
           
        }}
        close={handleClose}
        buttons={[
          {
            buttonModel: { isPrimary: true, content: 'Yes' },
            click: handleClose,
          },
          {
            buttonModel: { content: 'No' },
            click: handleClose,
          },
        ]}
      />
    </div>
  );
};

export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {
  const [visible, setVisible] = React.useState(false);

  const handleOpen = () => {
    setVisible(true);
  };

  const handleClose = () => {
    setVisible(false);
  };

  return (
    <div id="container" style=>
      <ButtonComponent onClick={handleOpen}>Open</ButtonComponent>
      <DialogComponent
        header="Delete Multiple Items"
        content="Are you sure you want to permanently delete all of these items?"
        showCloseIcon={true}
        visible={visible}
        width="300px"
        animationSettings=
        target="#container"
        beforeClose={(args) => {
          args.preventFocus = true;
        }}
        close={handleClose}
        buttons={[
          {
            buttonModel: { isPrimary: true, content: 'Yes' },
            click: handleClose,
          },
          {
            buttonModel: { content: 'NO' },
            click: handleClose,
          },
          
        ]}
      />
    </div>
  );
}

export default App;

[Functional-component]

import React, { useState } from 'react';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

const App = () => {
  const [visible, setVisible] = useState(false);

  const handleOpen = () => {
    setVisible(true);
  };

  const handleClose = () => {
    setVisible(false);
  };

  return (
    <div id="container" style=>
      <ButtonComponent onClick={handleOpen}>Open</ButtonComponent>
      <DialogComponent
        header="Delete Multiple Items"
        content="Are you sure you want to permanently delete all of these items?"
        showCloseIcon={true}
        visible={visible}
        width="300px"
        animationSettings=
        target="#container"
        beforeClose={(args) => {
          args.preventFocus = true;
           
        }}
        close={handleClose}
        buttons={[
          {
            buttonModel: { isPrimary: true, content: 'Yes' },
            click: handleClose,
          },
          {
            buttonModel: { content: 'No' },
            click: handleClose,
          },
        ]}
      />
    </div>
  );
};

export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {
  const [visible, setVisible] = React.useState(false);

  const handleOpen = () => {
    setVisible(true);
  };

  const handleClose = () => {
    setVisible(false);
  };

  return (
    <div id="container" style=>
      <ButtonComponent onClick={handleOpen}>Open</ButtonComponent>
      <DialogComponent
        header="Delete Multiple Items"
        content="Are you sure you want to permanently delete all of these items?"
        showCloseIcon={true}
        visible={visible}
        width="300px"
        animationSettings=
        target="#container"
        beforeClose={(args) => {
          args.preventFocus = true;
        }}
        close={handleClose}
        buttons={[
          {
            buttonModel: { isPrimary: true, content: 'Yes' },
            click: handleClose,
          },
          {
            buttonModel: { content: 'NO' },
            click: handleClose,
          },
          
        ]}
      />
    </div>
  );
}

export default App;

Prevent focus to previous element in Vue Dialog component

30 Aug 20256 minutes to read

By default, when the dialog is closed, focus returns to the element that was previously focused before the dialog opened. You can prevent this behavior using the beforeClose event and setting the preventFocus argument to true.

Bind the beforeClose event and enable the preventFocus argument as shown in the sample below.

<template>
  <div>
    <div id="target" class="control-section" style="height: 300px; position: relative;">
      <!-- Render Button to open the Dialog -->
      <ejs-button id="openBtn" @click="openDialog">Open</ejs-button>

      <!-- Render Dialog -->
      <ejs-dialog
        id="dialog"
        ref="dialogRef"
        :header="header"
        :content="content"
        :showCloseIcon="true"
        :buttons="buttons"
        :target="target"
        :width="width"
        :height="height"
        :animationSettings="animationSettings"
        :beforeClose="beforeClose"
      />
    </div>
  </div>
</template>

<script setup>
import { ref } from 'vue';
import { DialogComponent as EjsDialog } from '@syncfusion/ej2-vue-popups';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

const dialogRef = ref(null);
const target = 'body';
const header = 'Delete Multiple Items';
const content = 'Are you sure you want to permanently delete all of these items?';
const width = '300px';
const height = 'auto';
const animationSettings = { effect: 'Zoom' };

const openDialog = () => {
  dialogRef.value.show();
};

const closeDialog = () => {
  dialogRef.value.hide();
};

const beforeClose = (args) => {
  args.preventFocus = true;
};

const buttons = [
  {
    buttonModel: { isPrimary: true, content: 'Yes' },
    click: closeDialog,
  },
  {
    buttonModel: { content: 'No' },
    click: closeDialog,
  },
];
</script>

<style>

body {
  padding-top: 100px;
}

.control-section {
  height: 100%;
  min-height: 200px;
}
</style>
<template>
  <div>
    <div id="dialogTarget" class="control-section" style="height:300px; position:relative;">
      <!-- Render Button to open the Dialog -->
      <ejs-button id="dlgbtn" @click="dialogBtnClick">open</ejs-button>

      <!-- Render Dialog -->
      <ejs-dialog
        id="dialog"
        ref="Dialog"
        :header="header"
        :content="content"
        :showCloseIcon="true"
        :buttons="buttons"
        :target="target"
        :width="width"
        :height="height"
        :animationSettings="animationSettings"
        :beforeClose="beforeClose"
      />
    </div>
  </div>
</template>

<script>
import { DialogComponent } from '@syncfusion/ej2-vue-popups';
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

export default {
  name: "App",
  components: {
    "ejs-button": ButtonComponent,
    "ejs-dialog": DialogComponent
  },
  data: function() {
    return {
      target: "#dialogTarget",
      header: "Delete Multiple Items",
      content: "Are you sure you want to permanently delete all of these items?",
      width: "300px",
      height: "auto",
      animationSettings: { effect: "Zoom" },
      buttons: [
        {
          buttonModel: { isPrimary: true, content: "Yes" },
          click: this.dlgButtonClick
        },
        {
          buttonModel: { content: "No" },
          click: this.dlgButtonClick
        }
      ]
    };
  },
  methods: {
    dialogBtnClick() {
      this.$refs.Dialog.show();
    },
    dlgButtonClick() {
      this.$refs.Dialog.hide();
    },
    beforeClose(args) {
      args.preventFocus = true;
    }
  }
};
</script>

<style>

body {
  padding-top: 100px;
}

.control-section {
  height: 100%;
  min-height: 200px;
}
</style>

Prevent focus to the previous element in Angular Dialog component

30 Aug 20253 minutes to read

By default, when the dialog is closed, focus returns to the element that was previously focused before the dialog opened. You can prevent this behavior using the beforeClose event and setting the preventFocus argument to true.

Bind the beforeClose event and enable the preventFocus argument as shown in the sample below.

import { Component, ViewChild, OnInit, ElementRef } from '@angular/core';
import { DialogComponent, DialogModule } from '@syncfusion/ej2-angular-popups';
import { EmitType } from '@syncfusion/ej2-base';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [DialogModule],
  template: `
    <div #container class="root-container">
      <center>
        <button id="openBtn" class="e-control e-btn" (click)="onOpenDialog($event)">Open</button>
      </center>

      <ejs-dialog
        id="dialog"
        #ejDialog
        header="Delete Multiple Items"
        content="Are you sure you want to permanently delete all of these items?"
        [showCloseIcon]="true"
        [buttons]="buttons"
        [target]="targetElement"
        width="300px"
        height="auto"
        [animationSettings]="{ effect: 'Zoom' }"
        (beforeClose)="onBeforeClose($event)">
      </ejs-dialog>
    </div>
  `
})
export class AppComponent implements OnInit {
  @ViewChild('ejDialog') ejDialog!: DialogComponent;
  @ViewChild('container', { read: ElementRef }) container!: ElementRef;

  public targetElement?: HTMLElement;

  ngOnInit(): void {
    this.initializeTarget();
  }

  public initializeTarget: EmitType<object> = () => {
    this.targetElement = this.container.nativeElement.parentElement;
  };

  public onOpenDialog = (event: any): void => {
    this.ejDialog.show();
  };

  public onBeforeClose(args: any): void {
    args.preventFocus = true;
  }

  public hideDialog: EmitType<object> = () => {
    this.ejDialog.hide();
  };

  public buttons: Object[] = [
    {
      click: this.hideDialog.bind(this),
      buttonModel: {
        content: 'Yes',
        isPrimary: true
      }
    },
    {
      click: this.hideDialog.bind(this),
      buttonModel: {
        content: 'No'
      }
    }
  ];
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));